#include <hmg.ch>
#include "hblang.ch"

REQUEST HB_LANG_PL852
request HB_CODEPAGE_PL852
***********************************************************************************************
Function Main
Public cFont:="Arial", nFont:=9, cFontBrowse:="Consolas", nFontBrowse:=12

set( _SET_CODEPAGE, "PL852" )
hb_LangSelect( 'PL852')

DEFINE WINDOW start AT 0 , 0 WIDTH GetDesktopWidth() HEIGHT GetDesktopHeight()-40 TITLE "Program test" MAIN;

	ON KEY Escape ACTION ThisWindow.Release

	DEFINE BUTTON B_F2
        ROW    10
        COL    10
        WIDTH  200
        HEIGHT 28
        ACTION Przegladaj()
        CAPTION "Przegldaj STANY.DBF"
        FONTNAME cFont
        FONTSIZE nFont
    END BUTTON


END WINDOW

ACTIVATE WINDOW start
 
Return Nil

******************************************************************************
Function Przegladaj
Local i,pola:={},kol:={},tyt:={},justy:={},aKontrolki:={},aKiedyEdit:={},aValidEdit:={}
Local oWindow

SELE 0
oWindow:='Browse_stany_'+ALLTRIM(STR(SELECT()))
USE stany ALIAS &oWindow SHARED
COPY TO stru STRUCTURE EXTENDED

SELE 0
USE stru 
GO TOP
FOR i=1 TO LASTREC()
	AADD(pola,Field_name)
	AADD(kol,Field_len)
	AADD(tyt,Field_name)
	aTEdit=aControlEdit(Field_type)
	DO CASE
		CASE Field_type='C'
			AADD(justy,GRID_JTFY_LEFT)
			*AADD(aTEdit,REPLICATE('X',Field_len))
			*Definicja kontrolki dla pola o szerokosci 3 znakow powinna wygladac nastepujaco: {'TEXTBOX','CHARACTER','XXX'} 
			*Jakiego wzorca maski uzyc aby mozna bylo wprowadzic alfanumeryczne znaki, 'X' nie dziala na tej kontrolce?
			*Maska 'A' pozwala wprowadzic jedynie znaki alfabetu /bez specjalnych typu +-.,?:()*/, '9' tylko cyfry
			*Nie wiem jak zdefiniowac kontrolke edycji dla pola typu 'C', aby mozna bylo wprowadzic max ilosc znakow dowolnego typu
			*zalezna od szeokosci zdefiniowanego pola w pliku dbf
			*Teraz jest tak, ze pole ma np. szerokosc 3 znakow, a kontrolka pozwala wprowadzac wiecej znakow
			*Brakuje mi parametru do definicji kontrolki jakim bylby MAXLENGTH odpowiedni dla TEXTBOX'a lub znacznika maski 'X'
			AADD(aTEdit,REPLICATE(' ',Field_len))
			*Definicja kontrolki dla pola o szerokosci 3 znakow powinna wygladac nastepujaco: {'TEXTBOX','CHARACTER','   '}
		CASE Field_type='N'
			AADD(justy,GRID_JTFY_RIGHT)
			AADD(aTEdit,REPLICATE('9',Field_len-IF(Field_dec>0,Field_dec+1,0))+IF(Field_dec>0,'.'+REPLICATE('9',Field_dec),''))
		CASE Field_type='L'
			AADD(justy,GRID_JTFY_CENTER)
		OTHER
			AADD(justy,GRID_JTFY_LEFT)
	ENDCASE
	AADD(aKontrolki,aTEdit)
	AADD(aKiedyEdit,{|| .T.})
	AADD(aValidEdit,{|| .T.})
	SKIP
NEXT i
USE

//ustalam max szerokosci kolumn wg wzorca pol (GRID_WIDTH_AUTOSIZE dziala szybciej na pojedyczm rekordzie niz na calym pliku dbf)
kol:=GetGridCharWidth(kol,tyt)

SELECT &oWindow

SET NAVIGATION EXTENDED

M->mg:=InputWindow("Podaj magazyn (0=nie filtruj)",{"Nr magazynu "},{1},{'99'})
M->mg:=M->mg[1]
IF M->mg=Nil
	M->mg:=0
ENDIF
SET NAVIGATION STANDARD
IF M->mg#0
	SET FILTER TO mg=M->mg
	GO TOP
ENDIF

DEFINE WINDOW &oWindow AT 0, 0 WIDTH GetDesktopWidth() HEIGHT GetDesktopHeight()-40;
	TITLE 'Przegldanie STANY.DBF '+oWindow ;
	ON SIZE (SetProperty(oWindow,'stany','Width',GetProperty(oWindow,'Width')-35),;
			SetProperty(oWindow,'stany','Height',GetProperty(oWindow,'Height')-160)) ;
	ON MAXIMIZE (SetProperty(oWindow,'stany','Width',GetProperty(oWindow,'Width')-35),;
			SetProperty(oWindow,'stany','Height',GetProperty(oWindow,'Height')-160))

	ON KEY Escape ACTION ThisWindow.Release 
	
	DEFINE GRID stany
        ROW    30
        COL    10
        WIDTH  GetProperty(oWindow,'Width')-35
        HEIGHT GetProperty(oWindow,'Height')-160
        VALUE {1,1}
        WIDTHS kol
        HEADERS tyt
        FONTNAME cFontBrowse
        FONTSIZE nFontBrowse
        TOOLTIP ""
        MULTISELECT .F.
        ALLOWEDIT .T.
        VIRTUAL .F.
        DYNAMICBACKCOLOR Nil
        DYNAMICFORECOLOR Nil
        COLUMNWHEN aKiedyEdit
        COLUMNVALID aValidEdit
        COLUMNCONTROLS aKontrolki
        SHOWHEADERS .T.
        CELLNAVIGATION .T.
        NOLINES .F.
        JUSTIFY justy
        ROWSOURCE oWindow
        COLUMNFIELDS pola
        ALLOWAPPEND .F.
        ALLOWDELETE .F.
        BUFFERED .F.
        LOCKCOLUMNS LEN(pola)
    END GRID
    **Ustalam LockKolumns na wszystkie kolumny, bo chialem aby po zakonczeniu edycji pola, kursor nie przedzodzil do nastepnego.
    **Innego sposobu nie znalazlem
    
	DoMethod(oWindow,'stany','EnableUpdate()')

END WINDOW

SELE &oWindow

ACTIVATE WINDOW &oWindow

USE

RETURN
*************************************************************
Function aControlEdit(TypZmiennej)		&&ustalenuie kontrolek w zaleznosci od typu zmiennej
Local aTabEdit:={NIL}
DO CASE
	CASE TypZmiennej='C'
		aTabEdit:={'TEXTBOX','CHARACTER'}
	CASE TypZmiennej='N'
		aTabEdit:={'TEXTBOX','NUMERIC'}
	CASE TypZmiennej='D'
		aTabEdit:={'TEXTBOX','DATE'}
	CASE TypZmiennej='L'
		aTabEdit:={'CHECKBOX','Tak','Nie'}
	CASE TypZmiennej='M'
		aTabEdit:={'EDITBOX'}
ENDCASE

Return aTabEdit
*************************************************************
Function GetGridCharWidth(aKol,aTyt)		&&ustalenie max szerokosci kolumn w zaleznosci od wybranego fontu grida
Local aRows:=ARRAY(1,LEN(aKol))
Local aReturn:={},i,wzornik

FOR i=1 TO LEN(aKol)
	wzornik:=REPLICATE('W',aKol[i])		//znak 'W' przewaznie jest najszerszy ze wszystkich w danym foncie
	aRows[1,i]:=wzornik
NEXT i

DEFINE WINDOW oWinGridChar ;
	AT 0,0 ;
	WIDTH 300 ;
	HEIGHT 150 ;
	TITLE '' ;
	CHILD ;	
	NOSHOW ;
    NOSYSMENU ;
    NOCAPTION ; 
	ON INIT ThisWindow.Release

	DEFINE GRID Grid_1 
		ROW		5
		COL		5 
		WIDTH		290 
		HEIGHT		140 
		HEADERS		aTyt
		WIDTHS		aKol 
		ITEMS		aRows 
		CELLNAVIGATION	.T. 
		VALUE		{ 1, 1}
		FONTNAME cFontBrowse
		FONTSIZE nFontBrowse
	END GRID 
       
END WINDOW

FOR i=1 TO LEN(aKol)
	oWinGridChar.Grid_1.ColumnWIDTH(i):=GRID_WIDTH_AUTOSIZE
	AADD(aReturn,oWinGridChar.Grid_1.ColumnWIDTH(i))
NEXT i

//aktywuje okno, bo inaczej nie moge uzyc .Release i wyrzucic definicji okna z Ramu
ACTIVATE WINDOW oWinGridChar

RETURN aReturn
****************************************
